class Elem:
    def __init__(self, valeur, suivant=None):
        self.val = valeur
        self.suiv = suivant

def aff_liste(lst):   # Une fonction d'affichage des valeurs des éléments
    item = lst
    while item is not None:
        print(f"{item.val}", end=" ")
        item = item.suiv
    print()

lst = Elem("Premier")               # Création avec un élément
lst.suiv = Elem("Deuxieme")         # Ajout d'un deuxième
lst.suiv.suiv = Elem("Troisieme")   # Ajout d'un troisième
aff_liste(lst)                      # → Premier Deuxieme Troisieme 
item = lst
while item.suiv is not None:        # Parcours jusqu'à atteindre le dernier élément
    item = item.suiv
item.suiv = Elem("Quatrieme")       # Et on ajoute à la fin, où qu'elle soit
aff_liste(lst)                      # → Premier Deuxieme Troisieme Quatrieme 
lst = Elem("Zeroeme", lst)          # Ajout en tête
aff_liste(lst)                      # → Zeroeme Premier Deuxieme Troisieme Quatrieme 
prec = item = lst
